<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    @submit="onSubmitHandler"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :label="dictionaryRu.modal.name"
          v-model="formData.title"
          :disabled="true"
          :required="true"
          property="title"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          :label="dictionaryRu.modal.status"
          v-model="formData.is_active"
          :items="allowedStatus"
          display-exp="value"
          value-exp="key"
          :placeholder="dictionaryRu.modal.statusPlaceholder"
          :required="true"
          property="is_active"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :label="dictionaryRu.modal.type"
          :required="true"
          :value="formData.type ? dataSource.type_title : ''"
          :disabled="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          v-model="formData.contractor_role_codes"
          label
          :items="availableRoles"
          :placeholder="dictionaryRu.modal.roles + ' *'"
          display-exp="title"
          value-exp="code"
          property="status"
          :is-dropdown="true"
          :is-multiselect="true"
          :required="true"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin   from 'common-components/src/obComponents/obForm/FormValidationMixin';
import ObInput               from 'common-components/src/obComponents/obInput';
import ObSelect              from 'common-components/src/obComponents/obSelect';
import ObForm                from 'common-components/src/obComponents/obForm';
import models                from '@/models';
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/settings__admin__access'


export default {
  name: 'FunctionEdit',
  components: {
    ObSelect,
    ObInput,
    ObForm
  },
  mixins: [FormValidationMixin],
  props: {
    availableRoles: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  computed: {
    formModel() {
      return models.adminPanelModels.functionModel;
    },
    allowedStatus() {
      return [
        { key: false, value: this.dictionaryRu.statusValue.inactive },
        { key: true,  value: this.dictionaryRu.statusValue.active }
      ];
    }
  },
  methods: {
    close() {
      this.$emit('close');
    },
    onSubmitHandler() {
      this.$emit('save', this.formData);
    }
  }
};
</script>
